﻿@{
    ViewData["Title"] = "Firm Admin List";
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="datatable datatable-bordered" id="firm_list"></div>
        </div>
    </div>
</div>
<div class="modal" id="FirmAdminModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
@section scripts{
    <script>
        $(document).on("click", ".btn-admin-add", function () {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`admin/firmadmin/addfirmadmin?guid=${guid}`, "FirmAdminModal", null, function () {
                KTApp.unblockPage();
                bindPermissionMultiselect2();
                $("#FirmAdminModal").modal({ backdrop: 'static' });
            });
        });
        var adminTable = function (e) {
            var id = e.data.id;
            var ktDataTablOptions = ktDataTableDefaultConfigOptions;
            ktDataTablOptions.source = `admin/superadmin/fetchadmins?firmId=${id}&role=${AdminRoleEnum.FIRMADMIN}`;
            window['sub_datatable_' + id] = $('<div/>').attr('id', `firm_list_${id}`).appendTo(e.detailCell).KTDatatable({
                data: ktDataTablOptions,
                columnFilter: true,
                columns: [
                    { field: 'id', title: '#', width: 85, filter: { maxlength: 5, additionalClasses: "numericOnly-no-placeholder" } },
                    {
                        field: 'userData.name', sortable: 'asc', title: 'Name/Email', width: 330, filter: { container: "AdviserName" },
                        template: function (row) {
                            var isValidDate = row.setupCompletedDate != null && row.setupCompletedDate.length > 2
                            var initial = [row.userData.firstName, row.userData.lastName].map((n) => n[0]).join("").substring(0, 2);
                            var color = getRandomColor();
                            var warningHtml = !isValidDate ?
                                `<span class="fa-stack pulse pulse-warning ml-2" data-toggle="tooltip" data-html="true" data-original-title="Complete the Password setup process" data-placement="right" role = "button" >
                                                            <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                            <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                            <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                        </span>` : '';
                            return `<div class="d-flex align-items-center">
                                                            <div class="symbol symbol-40 flex-shrink-0">
                                                                 <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                            </div>
                                                            <div class="ml-2">
                                                                <div class="text-dark-75 font-weight-bold line-height-sm">${row.userData.name}</div>
                                                                <div class="text-primary">${row.username}</div>
                                                            </div>
                                                            ${warningHtml}
                                                        </div>`;
                        }
                    },
                    {
                        field: 'roles', title: 'Roles', sortable: false, width: 190, filter: { filterType: "select", additionalClasses: `roles-filter-dropdown-${id}` },
                        template: function (row) {
                            var label_class = "";
                            label_class = row.adminRole == AdminRoleEnum.FIRMPRINCIPAL ? "dark" : row.adminRole == AdminRoleEnum.FIRMADMIN ? "warning" : row.adminRole == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                            var html = `<span class="label label-outline-${label_class} label-inline mr-2 mb-2 font-weight-bold">${row.adminRoleString}</span>`;
                            row.permissions.forEach(function (item) {
                                label_class = item.roleType == AdminRoleEnum.FIRMADMIN ? "warning" : item.roleType == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                                html += `<span class="label label-${label_class} label-inline mr-2 mb-2">${item.roleTypeString}</span>`;
                            })
                            return html;
                        }
                    },
                    {
                        field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 125,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.setupCompletedDate)
                        },
                    },
                    {
                        field: 'lastLogin', title: 'Last Login', sortable: false, width: 80,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.lastLogin)
                        }
                    },
                    {
                        field: 'actions', title: 'Actions', width: 100, sortable: false, overflow: 'visible',
                        template: function (row) {
                            var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                            var resend_html = !isSetupCompleted ? `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.FIRMADMIN},'${row.guid}')">
                                                                <img src="/images/email-resend-icon.png" height="25" />
                                                                <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 64px;top: 29px;"></i>
                                                            </button>` : "";
                            return `<button class="btn btn-sm btn-icon mr-2 btn-admin-add" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                                                 <img src="/images/edit-icon.png" height="25" />
                                                            </button>
                                                            ${resend_html}`;
                        },
                    }
                ],
            })
            $(`#firm_list_${id}`).on('datatable-on-init', function (e, data) {
                bindRolesDropdown(id);
            });
        }
        bindFirmsGrid("FirmAdmin", adminTable);
    </script>
}